# AudioKit Examples

## HelloWorld for iOS, macOS, and tvOS

Hello World plays an oscillator based sound and displays the sound's waveform. This example is available on all supported operating systems.

## Examples for iOS and macOS

* AKSampler Demo - try the new AKSampler instrument with MIDI
* Audio Unit Manager - host audio units inside your application
* File Converter - convert various file types
* Microphone Analysis - frequency and amplitude information from the incoming audio stream
* MIDI Utility - Basic MIDI implementation including MIDI monitoring
* Random Clips - Demonstration of some of the new sample accurate functionality in AudioKit 4
* Recorder - Simple audio recorder
* Sporth Editor - A graphical user interface to the Sporth audio language

## Examples for iOS only

* Analog Synth X - polyphonic synthesizer with a very nice user interface
* Drums - trigger drum sounds from 8 pads on your iOS device
* Filter Effects - Audiobus enabled effects processing
* Hello Objective-C - Hello World in the Objective-C language (as opposed to Swift)
* Metronome Sampler Sync - highly accurate, sample triggering metronome
* Particles - Metal based audio visualizer (works on devices only, not the simulator)
* Sampler Demo - example of AudioKit's AKAppleSampler
* Sender Synth - Audiobus enabled synthesizer
* Sequencer Demo - examjple of AudioKit's AKSequencer
* Song Processor - adding effects to songs from the device's iTunes Library 
